#include <array>
#include <complex>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <random>
#include <set>
#include <string>
#include <valarray>
#include <vector>
#include <fftw3.h>
#include <boost/program_options.hpp>
#include <boost/numeric/odeint.hpp>